YAZ User's Guide and Reference
Prev | Chapter 2. Compilation and Installation | Next

# UNIX

We provide Debian GNU/Linux and Redhat packages for YAZ. Only i386 binary packages are available. You should be able to create packages for other CPUs by building them from the source package.

## Compiling from source on Unix

Note that if your system doesn't have a native ANSI C compiler, you may have to acquire one separately. We recommend GCC.

If you wish to use character set conversion facilities in YAZ or if you are compiling YAZ for use with Zebra it is a good idea to ensure that the iconv library is installed. Some Unixes today already have it - if not, we suggest GNU iconv.

The XML C library libxml2 is required if YAZ is to support SRW and SRU. This library is very portable and should compile out-of-the box on virtually all Unix platforms. It is available in binary forms for Linux and others.

The GNU tools Autoconf, Automake and Libtool are used to generate Makefiles and configure YAZ for the system. You do not these tools unless you're using the CVS version of YAZ.

The CQL parser for YAZ is built using GNU Bison. This tool is only needed if you're using the CVS version of YAZ.

YAZ includes a tiny ASN.1 compiler. This compiler is written in Tcl. But as for Bison you do not need it unless you're using CVS version of YAZ or you're using the compiler to built own codecs for private ASN.1.

Generally it should be sufficient to run configure without options, like this:

         ./configure

The configure script attempts to use use the C compiler specified by the CC environment variable. If not set, GNU C will be used if it is available. The CFLAGS environment variable holds options to be passed to the C compiler. If you're using Bourne-compatible shell you may pass something like this to use a particular C compiler with optimization enabled:

         CC=/opt/ccs/bin/cc CFLAGS=-O ./configure

To customize YAZ, the configure script also accepts a set of options. The most important are:

--prefix=prefix

  Specifies installation prefix for YAZ. This is only needed if you run make install later to perform a "system" installation. The prefix is /usr/local if not specified.

--enable-tcpd

  The front end server will be built using Wietse's TCP wrapper library. It allows you to allow/deny clients depending on IP number. The TCP wrapper library is often used in Linux/BSD distributions. See hosts_access(5) and tcpd(8).

--enable-threads

  YAZ will be built using POSIX threads. Specifically, `_REENTRANT` will be defined during compilation.

--enable-shared

  The make process will create shared libraries (also known as shared objects `.so`). By default, no shared libraries are created - equivalent to --disable-shared.

--disable-shared

  The make process will not create static libraries (`.a`). By default, static libraries are created - equivalent to --enable-static.

--with-iconv[=prefix]

  Compile YAZ with iconv library in directory prefix. By default configure will search for iconv on your system. Use this option if it doesn't find iconv. Alternatively you can use --without-iconv to force YAZ not to use iconv.

--with-xml2[=prefix]

  Compile YAZ with libxml2 in directory prefix. Use this option if you want SOAP support. By default configure will search for libxml2 on your system. Use this option if it doesn't find libxml2. Alternatively you can use --without-xml2 to force YAZ not to use libxml2.

--with-openssl[=prefix]

  YAZ will be linked with the OpenSSL libraries and an SSL COMSTACK will be provided. Note that SSL support is still experimental.

When configured, build the software by typing:

          make

The following files are generated by the make process:

`src/libyaz.la`

  Main YAZ library. This is no ordinary library. It's a Libtool archive. By default, YAZ creates a static library in `lib/.libs/libyaz.a`.

`src/libyazthread.la`

  When threading is supported/enabled by configure this Libtool library is created. It includes functions that allows YAZ to use threads.

`ztest/yaz-ztest`

  Test Z39.50 server.

`client/yaz-client`

  Z39.50 client for testing the protocol. See chapter YAZ client for more information.

`util/yaz-config`

  A Bourne-shell script, generated by configure, that specifies how external applications should compile - and link with YAZ.

`util/yaz-asncomp`

  The ASN.1 compiler for YAZ. Requires the Tcl Shell, tclsh, in PATH to operate.

`util/yaz-iconv`

  This program converts data in one character set to another. This command exercises the YAZ character set conversion API.

`util/yaz-marcdump`

  This program parses ISO2709 encoded MARC records and prints them in line-format or XML.

`zoom/zoomsh`

  A simple shell implemented on top of the ZOOM functions. The shell is a command line application that allows you to enter simple commands to perform ZOOM operations.

`zoom/zoomtst1`, `zoom/zoomtst2`, ..

  Several small applications that demonstrates the ZOOM API.

If you wish to install YAZ in system directories `/usr/local/bin`, `/usr/local/lib` .. etc, you can type:

         make install

You probably need to have root access in order to perform this. You must specify the --prefix option for configure if you wish to install YAZ in other directories than the default `/usr/local/`.

If you wish to perform an un-installation of YAZ, use:

         make uninstall

This will only work if you haven't reconfigured YAZ (and therefore changed installation prefix). Note that uninstall will not remove directories created by make install, e.g. `/usr/local/include/yaz`.

## How to make apps using YAZ on UNIX

This section describes how to compile - and link your own applications using the YAZ toolkit. If you're used to Makefiles this shouldn't be hard. As for other libraries you have used before, you have to set a proper include path for your C/C++ compiler and specify the location of YAZ libraries. You can do it by hand, but generally we suggest you use the `yaz-config` that is generated by `configure`. This is especially important if you're using the threaded version of YAZ which require you to pass more options to your linker/compiler.

The `yaz-config` script accepts command line options that makes the `yaz-config` script print options that you should use in your make process. The most important ones are: --cflags, --libs which prints C compiler flags, and linker flags respectively.

A small and complete Makefile for a C application consisting of one source file, `myprog.c`, may look like this:

          YAZCONFIG=/usr/local/bin/yaz-config
          CFLAGS=`$(YAZCONFIG) --cflags`
          LIBS=`$(YAZCONFIG) --libs`
          myprog: myprog.o
             $(CC) $(CFLAGS) -o myprog myprog.o $(LIBS)

The CFLAGS variable consists of a C compiler directive that will set the include path to the parent directory of `yaz`. That is, if YAZ header files were installed in `/usr/local/include/yaz`, then include path is set to `/usr/local/include`. Therefore, in your applications you should use

          #include <yaz/proto.h>

and not

          #include <proto.h>

For Libtool users, the `yaz-config` script provides a different variant of option --libs, called --lalibs that returns the name of the Libtool acrhive(s) for YAZ rather than the ordinary ones.

For applications using the threaded version of YAZ, specify threads after the other options. When threads is given, more flags and linker flags will be printed by `yaz-config`. If our previous example was using threads, you'd have to modify the lines that set CFLAGS and LIBS as follows:

          CFLAGS=`$(YAZCONFIG) --cflags threads`
          LIBS=`$(YAZCONFIG) --libs threads`

There is no need specify POSIX thread libraries in your Makefile. The LIBS variable includes that as well.

Prev | Home | Next
Compilation and Installation | Up | WIN32